<template>
  <div class="ele-body">
    <a-card style="width: 100%" :bordered="false">
      <template #title>
        <a-space>
          <a-upload
            :before-upload="importFileSewage"
            :showUploadList="false"
            accept=".xls,.xlsx,.csv"
          >
            <a-button>黑臭水体导入</a-button>
          </a-upload>
          <a-upload
            :before-upload="importFileCityRiver"
            :showUploadList="false"
            accept=".xls,.xlsx,.csv"
          >
            <a-button>城市内河导入</a-button>
          </a-upload>
        </a-space>
      </template>
      <a-tabs v-model:activeKey="activeKey">
        <a-tab-pane tab="黑臭水体" key="water">
          <water-bill ref="water"></water-bill>
        </a-tab-pane>
        <a-tab-pane tab="城市内河" key="special">
          <city-river-bill ref="cityRiver"></city-river-bill>
        </a-tab-pane>
      </a-tabs>
    </a-card>
  </div>
</template>

<script>
import XLSX from "xlsx";
import utils from "./utils";
import {Modal} from "ant-design-vue";
import WaterBill from "./water-bill.vue";
import CityRiverBill from "./city-river-bill.vue";
import {saveSewageBill as saveCityRiverBill} from "@/api/ecology/sewage-city-river";
import {saveSewageBill} from "@/api/ecology/sewage";

export default {
  name: "BlackSmellyWaterCollectIndex",
  components: {
    WaterBill,
    CityRiverBill
  },
  data() {
    return {
      activeKey: "water",
    };
  },
  methods: {
    /* 导入本地excel文件 */
    importFileSewage(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();
      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });

          const reportDateStr = aoa[0][0].replace(/[^\d]+/g, "-");
          console.log(reportDate)
          const reportDate = new Date();
          reportDate.setFullYear(reportDateStr.split("-")[0]);
          reportDate.setMonth(reportDateStr.split("-")[1]);
          const blackSmellyWaterList = aoa.filter(
            (item) => {
              return item.length >= 7 && item[0] && typeof item[0] == "number";
            }
          );


          // 解析成对象数组
          const billName = aoa[0][0];
          const billData = utils.toBlackSmellyWaterObjData(blackSmellyWaterList,reportDate.getTime());
          if (!billData || billData.length == 0) {
            hide()
            Modal.error({
              title: "导入失败",
              content: "找不到数据",
            });
            return;
          }
          const tasks = [];
          if (billData.length > 0) {
            tasks.push(
              saveSewageBill({
                billName: billName,
                blackSmellyWaterList: billData,
              })
            );
          }


          // 上传到服务器

          Promise.all(tasks)
            .then((res) => {
              if (res[0].data.code == 0) {
                Modal.success({
                  title: "导入成功",
                  content: `成功导入${billData.length}条数据`,
                });
                this.$refs.water && this.$refs.water.reload();
              } else {
                Modal.error({
                  title: "导入失败",
                  content: "数据上传出错",
                });
              }

            })
            .catch(() => {
              Modal.error({
                title: "导入失败",
                content: "数据上传出错",
              });
            })
            .finally(() => {
              hide();
            });
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);

      return false;
    },
    importFileCityRiver(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();
      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });

          const reportDate = aoa[2][0].replace(/[^\d]+/g, "-");

          const cityRiverList = aoa.filter(
            (item) => {
              return item.length >= 37 && item[0] && !item[0].includes("点位名称");
            }
          );
          // 解析成对象数组
          const billName = file.name;

          const billData = utils.toCityInnerRiverObjData(cityRiverList,new Date(reportDate).getTime());
          if (!billData || billData.length == 0) {
            hide()
            Modal.error({
              title: "导入失败",
              content: "找不到数据",
            });
            return;
          }
          const tasks = [];
          if (billData.length > 0) {
            tasks.push(
              saveCityRiverBill({
                billName: billName,
                blackSmellyWaterCityRiverList: billData,
              })
            );
          }


          // 上传到服务器

          Promise.all(tasks)
            .then((res) => {
              if (res[0].data.code == 0) {
                Modal.success({
                  title: "导入成功",
                  content: `成功导入${billData.length}条数据`,
                });
                this.$refs.water && this.$refs.water.reload();
              } else {
                Modal.error({
                  title: "导入失败",
                  content: "数据上传出错",
                });
              }

            })
            .catch(() => {
              Modal.error({
                title: "导入失败",
                content: "数据上传出错",
              });
            })
            .finally(() => {
              hide();
            });
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);

      return false;
    },


  },
};
</script>

<style scoped lang="less">
</style>
